#include <stdio.h>
#include "bldc.h"
#include "wait.h"
#include "r_can_api.h"
#include "cprintf.h"

/*  CAN_TX is P2.3
    CAN_RX is P2.2 */

main()
{
  int i, rv;
  int last_tx = 0;
  can_std_frame_t frame;

  bldc_init ();

  tty_puts("Hello from CAN 2!\n");

  /* Shut off the motor.  */
  PORTB.DR.BYTE = UL | VL | WL;

  R_CAN_PortSet (0, ENABLE);
  R_CAN_PortSet (0, CANPORT_TEST_0_EXT_LOOPBACK);

  rv = R_CAN_Create (0);
  switch (rv)
    {
    case R_CAN_OK: tty_puts("Create OK\r"); break;
    case R_CAN_SW_BAD_MBX: tty_puts("Create bad mailbox\n"); break;
    case R_CAN_BAD_CH_NR: tty_puts("Create bad channel\n"); break;
    case R_CAN_SW_RST_ERR: tty_puts("Create no reset\n"); break;
    default: cprintf("Create other error %d\n", rv); break;
    }
  cprintf("created\n");

  R_CAN_RxSet (0, 4, 0x123, DATA_FRAME);
  R_CAN_RxSetMask (0, 4, 0);

  while (1)
    {
      if (msec - last_tx > 3000)
	{
	  frame.id = 0x55;
	  frame.dlc = 5;
	  frame.data[0] = 0x55;
	  for (i=1; i<8; i++)
	    frame.data[i] = i;
	  rv = R_CAN_TxSet (0, 3, &frame, DATA_FRAME);
	  switch (rv)
	    {
	    case R_CAN_OK: tty_puts("TxSet OK\r"); break;
	    case R_CAN_SW_BAD_MBX: tty_puts("TxSet Bad Mailbox\n"); break;
	    case R_CAN_BAD_CH_NR: tty_puts("TxSet bad channel\n"); break;
	    case R_CAN_BAD_ACTION_TYPE: tty_puts("TxSet bad action\n"); break;
	    }
	  last_tx = msec;
	}
      for (i=0; i<32; i++)
	if (i != 3)
	  if (R_CAN_RxPoll (0, i) == R_CAN_OK)
	    {
	      can_std_frame_t fr;
	      R_CAN_RxRead (0, i, &fr);
	      cprintf("mb %d id %d len %d\033[K\n", i, (int)fr.id, (int)fr.dlc);
	    }
      cprintf (" %b :", CAN0.MCTL[4].BYTE);
      {
	unsigned char *mb = (unsigned char *)(&CAN0.MB[4]);
      for (i=0; i<16; i++)
	cprintf(" %b", mb[i]);
      }
      cprintf("\r");
    }
}
