#include <stdio.h>
#include "bldc.h"
#include "r_flash_api_rx600.h"

#define dflash ((char *)0x00100000)

static void
blanks ()
{
  int i, r;
  for (i=0; i<24; i++)
    {
      if ((r=R_FlashDataAreaBlankCheck (dflash+i*8, BLANK_CHECK_8_BYTE)) == FLASH_BLANK)
	printf(" \033[32m%02x", i*8);
      else
	printf(" \033[31m%02d", r);
    }
  printf("\033[34m");
  for (i=0; i<24; i++)
    {
      printf(" %02x", dflash[i]);
      if (isgraph (dflash[i]))
	printf("%c", dflash[i]);
      else
	printf(" ");
    }
  printf("\033[0m\n");
}

char buffer[] = "DJ Was Here";

main()
{
  int i;
  bldc_init ();

  tty_puts("\nflash 1\n");

  R_FlashDataAreaAccess (~0, ~0);

  blanks();

  i = R_FlashErase(BLOCK_DB0);
  switch (i)
    {
    case FLASH_SUCCESS: printf("erase ok\n"); break;
    case FLASH_FAILURE: printf("erase fail\n"); break;
    case FLASH_BUSY:    printf("erase busy\n"); break;
    }

  blanks();

  i = R_FlashWrite (dflash + 8, buffer, 8);
  switch (i)
    {
    case FLASH_SUCCESS:		printf("write ok\n"); break;
    case FLASH_FAILURE:		printf("write fail\n"); break;
    case FLASH_BUSY:		printf("write busy\n"); break;
    case FLASH_ERROR_ALIGNED:	printf("write unaligned\n"); break;
    case FLASH_ERROR_BYTES:	printf("write count wrong\n"); break;
    case FLASH_ERROR_ADDRESS:	printf("write addr wrong\n"); break;
    case FLASH_ERROR_BOUNDARY:	printf("write boundary wrong\n"); break;
    }

  blanks();

  write(1, "\3\3\0", 3);
  while (1);
}
